/* Object-REXX-Pgm ODUS.cmd zur Erzeugung von SUDOKU-Rtseln 28.02.06 */
/* Die Bildschirmgre sollte unbedingt 1280x1024 sein.               */
"@ echo off"
"@ mode 82,44"

Call RxFuncAdd 'SysLoadFuncs', RexxUtil, 'SysLoadFuncs'
Call SysLoadFuncs
call SysCls
signal on halt name PgmEnd		

pfd=Directory()
/* Die Funktion  Directory()  erzeugt nicht immer einen Bachslash */
/* am Ende eines Pfades; daher die folgende Prozedur              */
if LastPos("\", pfd)<>length(pfd) then do
  sudo=pfd||"\"||SUDO.DAT
end
else do
  sudo=pfd||SUDO.DAT
end
/* Datei sudo freigeben, weil sie sonst nicht gelscht werden kann. */
call Charout(sudo)
"del" sudo "1>NUL 2>NUL"
/*gnal terpull*/

call Locate 12,7
call Charout,"Es gibt Menschen, denen Buchstaben sympatischer als Zahlen sind."
/*
call Locate 11,7
call Charout,"gibt es in dem folgenden Programm die Wahlmglichkeit,"
call Locate 12,7
call Charout,"ein SODUKU-Rtsel entweder mit Buchstaben oder Zahlen mit auszustatten."
*/
call Locate 14,7
call Charout,"Mit dem folgenden Programm knnen Sie SUDOKU-Rtsel erzeugen,"
call Locate 15,7
call Charout,"fr deren Felder zwei verschiedene Arten von Symbolen whlbar sind,"
call Locate 16,7
call Charout,"nmlich entweder Buchstaben oder Zahlen."
call Locate 18,7
call Charout,"Mchten Sie fr das folgende SUDOKU-Rtsel als Symbole" 
call Locate 19,7
call Charout,"Buchstaben? (b)" 
ent0:
call Locate 20,7
call Charout,"oder Zahlen (z) whlen ?  "; pull entZB

select 
  when entZB=='Z' then signal weiter /* Diese Entscheidung wird   */
  when entZB=='B' then signal weiter /* weiter unten ausgewertet. */
  otherwise 
  do
    call Locate 20,33
    Beep(884,200)
    call Charout,"                                              "
    signal ent0
  end
end
weiter:
 
call Locate 14,10
call Charout,"                                                                  " 

/* Sicherheits-Version der Daten eines SUDOKU-Gesamtfeldes; nicht verndern! */
/* Diese Zahlenwerte entsprechen den SUDOKU-Regeln.                           */
/*
f.1.1=8; f.1.2=7; f.1.3=5; f.1.4=1; f.1.5=9; f.1.6=6; f.1.7=3; f.1.8=4; f.1.9=2;
f.2.1=2; f.2.2=3; f.2.3=1; f.2.4=7; f.2.5=8; f.2.6=4; f.2.7=5; f.2.8=9; f.2.9=6;
f.3.1=9; f.3.2=4; f.3.3=6; f.3.4=2; f.3.5=3; f.3.6=5; f.3.7=1; f.3.8=8; f.3.9=7;
f.4.1=1; f.4.2=2; f.4.3=9; f.4.4=3; f.4.5=6; f.4.6=8; f.4.7=7; f.4.8=5; f.4.9=4;
f.5.1=5; f.5.2=6; f.5.3=3; f.5.4=4; f.5.5=2; f.5.6=7; f.5.7=9; f.5.8=1; f.5.9=8;
f.6.1=4; f.6.2=8; f.6.3=7; f.6.4=5; f.6.5=1; f.6.6=9; f.6.7=6; f.6.8=2; f.6.9=3;
f.7.1=3; f.7.2=5; f.7.3=4; f.7.4=8; f.7.5=7; f.7.6=1; f.7.7=2; f.7.8=6; f.7.9=9; 
f.8.1=6; f.8.2=1; f.8.3=2; f.8.4=9; f.8.5=4; f.8.6=3; f.8.7=8; f.8.8=7; f.8.9=5;
f.9.1=7; f.9.2=9; f.9.3=8; f.9.4=6; f.9.5=5; f.9.6=2; f.9.7=4; f.9.8=3; f.9.9=1;
*/

vonvorn:
/* Diese (gleichen) Werte werden verwendet */
f.1.1=8; f.1.2=7; f.1.3=5; f.1.4=1; f.1.5=9; f.1.6=6; f.1.7=3; f.1.8=4; f.1.9=2;
f.2.1=2; f.2.2=3; f.2.3=1; f.2.4=7; f.2.5=8; f.2.6=4; f.2.7=5; f.2.8=9; f.2.9=6;
f.3.1=9; f.3.2=4; f.3.3=6; f.3.4=2; f.3.5=3; f.3.6=5; f.3.7=1; f.3.8=8; f.3.9=7;
f.4.1=1; f.4.2=2; f.4.3=9; f.4.4=3; f.4.5=6; f.4.6=8; f.4.7=7; f.4.8=5; f.4.9=4;
f.5.1=5; f.5.2=6; f.5.3=3; f.5.4=4; f.5.5=2; f.5.6=7; f.5.7=9; f.5.8=1; f.5.9=8;
f.6.1=4; f.6.2=8; f.6.3=7; f.6.4=5; f.6.5=1; f.6.6=9; f.6.7=6; f.6.8=2; f.6.9=3;
f.7.1=3; f.7.2=5; f.7.3=4; f.7.4=8; f.7.5=7; f.7.6=1; f.7.7=2; f.7.8=6; f.7.9=9; 
f.8.1=6; f.8.2=1; f.8.3=2; f.8.4=9; f.8.5=4; f.8.6=3; f.8.7=8; f.8.8=7; f.8.9=5;
f.9.1=7; f.9.2=9; f.9.3=8; f.9.4=6; f.9.5=5; f.9.6=2; f.9.7=4; f.9.8=3; f.9.9=1;
                 
nnn:
u=1
do while u<=10
  n1=random(1,9) 
  n2=random(1,9) 
  if n1==n2 then signal nnn
        
  /* Zunchst fr alle Variablen  f.z.s  Werte z und s vertauschen  */  
  z=1     
  do while z<=9
    s=1 
    do while s<=9
      if f.z.s==n1 then 
      do
        f.z.s=u01
      end
      if f.z.s==n2 then 
      do
        f.z.s=u02    /* u02 */
      end
      s=s+1
    end /* Ende der s-Schleife */
    z=z+1
  end /* Ende der z-Schleife */
  
  z=1     
  do while z<=9
    s=1 
    do while s<=9
      if f.z.s==u01 then 
      do
        f.z.s=n2
      end
      if f.z.s==u02 then 
      do
        f.z.s=n1
      end
      s=s+1
    end /* Ende der s-Schleife */
    z=z+1
  end /* Ende der z-Schleife */
  u=u+1  
end
            
/* Sicherheitsprfung */  
z=1     
do while z<=9
  s=1 
  do while s<=9
    /* Fehlermeldung, wenn in einer der Zeilen eine Zahl doch mehrfach auftaucht  */
    /* Diese Zeilen-Prfbefehle mssen vor Spalten-Prfbefehlen stehen.           */
    z_str=f.z.1 f.z.2 f.z.3 f.z.4 f.z.5 f.z.6 f.z.7 f.z.8 f.z.9
    zz=countstr(f.z.s, z_str)
    if zz>>1 then call Fehler_z("in  Zeile "z)
    /* Fehlermeldung, wenn in einer der Spalten eine Zahl doch mehrfach auftaucht */
    /* Diese Spalten-Prfbefehle mssen vor Zeilen-Prfbefehlen stehen.           */
    s_str=f.1.s f.2.s f.3.s f.4.s f.5.s f.6.s f.7.s f.8.s f.9.s
    zz=countstr(f.z.s, s_str)
    if zz>>1 then call Fehler_s("in Spalte "s)
    s=s+1
  end /* Ende der s-Schleife */
  z=z+1
end /* Ende der z-Schleife */

if entZB='Z' then signal Zahlen

/* Zunchst Zahlen 1 bis 9 gegen die Buchstaben A bis I tauschen  */  
z=1     
do while z<=9
  s=1 
  do while s<=9
    if f.z.s==1 then f.z.s=A 
    if f.z.s==2 then f.z.s=B
    if f.z.s==3 then f.z.s=C
    if f.z.s==4 then f.z.s=D
    if f.z.s==5 then f.z.s=E
    if f.z.s==6 then f.z.s=F 
    if f.z.s==7 then f.z.s=G
    if f.z.s==8 then f.z.s=H  
    if f.z.s==9 then f.z.s=I 
    s=s+1
  end /* Ende der s-Schleife */
  z=z+1
end /* Ende der z-Schleife */
                    
Zahlen:                       
call Locate 1,1; say
call Charout,"         ͻ"; say
call Charout,"                                                               "; say 
call Charout,"           "f.1.1"     "f.1.2"     "f.1.3 "    "f.1.4"     "f.1.5"     "f.1.6"     "f.1.7"     "f.1.8"     "f.1.9"   "; say  
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.2.1"     "f.2.2"     "f.2.3 "    "f.2.4"     "f.2.5"     "f.2.6"     "f.2.7"     "f.2.8"     "f.2.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.3.1"     "f.3.2"     "f.3.3 "    "f.3.4"     "f.3.5"     "f.3.6"     "f.3.7"     "f.3.8"     "f.3.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         ͹"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.4.1"     "f.4.2"     "f.4.3 "    "f.4.4"     "f.4.5"     "f.4.6"     "f.4.7"     "f.4.8"     "f.4.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.5.1"     "f.5.2"     "f.5.3 "    "f.5.4"     "f.5.5"     "f.5.6"     "f.5.7"     "f.5.8"     "f.5.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.6.1"     "f.6.2"     "f.6.3 "    "f.6.4"     "f.6.5"     "f.6.6"     "f.6.7"     "f.6.8"     "f.6.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         ͹"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.7.1"     "f.7.2"     "f.7.3 "    "f.7.4"     "f.7.5"     "f.7.6"     "f.7.7"     "f.7.8"     "f.7.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.8.1"     "f.8.2"     "f.8.3 "    "f.8.4"     "f.8.5"     "f.8.6"     "f.8.7"     "f.8.8"     "f.8.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "f.9.1"     "f.9.2"     "f.9.3 "    "f.9.4"     "f.9.5"     "f.9.6"     "f.9.7"     "f.9.8"     "f.9.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         ͼ";

call Locate 40,5
call Charout,"Soll von diesem Sudoku-Gesamtfeld ein SUDOKU-Rtsel erzeugt werden? (j),"
call Locate 41,2
call Charout,"oder soll ein SUDOKU-Gesamtfeld mit anderen Symbolpositionen erzeugt werden? (a),";
qp1:    
call Locate 42,48
call Charout,"                                "
call Locate 42,5
call Charout,"oder soll das Programm verlassen werden? (v) "
ret=SysCurState("ON"); pull ent1; ret=SysCurState("OFF")

select 
  when ent1=='J' then signal leer
  when ent1=='A' then signal vonvorn
  when ent1=='V' then signal PgmEnd
  otherwise 
  do
    call Locate 42,4
    Beep(884,200)
    call Charout,"           "
    signal qp1
  end
end
leer:

sudvers: 
neu1:
call SysCls
call Locate 18,2
call Charout,"Fr ein SUDOKU-Rtsel mssen an zufallsbedingten Stellen des Gesamtfeldes"; 
call Locate 19,2
call Charout,"freie Felder erzeugt werden. Wie viele freie Felder sollen erzeugt werden? "; 
Beep(1200,500)
ret=SysCurState("ON"); pull nl; ret=SysCurState("OFF")
if DataType(nl, "W")<>1 | nl >= 81 | nl<0 then
do 
  call Locate 19,70
  Beep(884,200)
  call Charout,"           "
  signal neu1
end

call Locate 18,2
call Charout,"                                                                               "; 
call Locate 19,2
call Charout,"                                                                               "; 

zufleer:
/* Zunchst werden alle Variablen g.z.s = f.z.s eingestellt */  
z=1     
do while z<=9
  s=1 
  do while s<=9
    g.z.s=f.z.s
    s=s+1
  end /* Ende der s-Schleife */
  z=z+1
end /* Ende der z-Schleife */

/* Erzeugung von nl zufllig angeordneten Leerfeldern fr ein SUDUKO-Rtsel. */              
i=1              
anfi:
do while i<=nl
  z=random(1,9); s=random(1,9)
  if g.z.s=" " then signal anfi
  g.z.s=" "
  i=i+1
end

/* call SysCls   */
/* Speicherung in der Datei sudo=pfd||SUDO.DAT */ 
ret=LineOut(sudo,"        ͻ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.1.1"     "g.1.2"     "g.1.3 "    "g.1.4"     "g.1.5"     "g.1.6"     "g.1.7"     "g.1.8"     "g.1.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        Ĺ") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.2.1"     "g.2.2"     "g.2.3 "    "g.2.4"     "g.2.5"     "g.2.6"     "g.2.7"     "g.2.8"     "g.2.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        Ĺ") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.3.1"     "g.3.2"     "g.3.3 "    "g.3.4"     "g.3.5"     "g.3.6"     "g.3.7"     "g.3.8"     "g.3.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        ͹") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.4.1"     "g.4.2"     "g.4.3 "    "g.4.4"     "g.4.5"     "g.4.6"     "g.4.7"     "g.4.8"     "g.4.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        Ĺ") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.5.1"     "g.5.2"     "g.5.3 "    "g.5.4"     "g.5.5"     "g.5.6"     "g.5.7"     "g.5.8"     "g.5.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        Ĺ") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.6.1"     "g.6.2"     "g.6.3 "    "g.6.4"     "g.6.5"     "g.6.6"     "g.6.7"     "g.6.8"     "g.6.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        ͹") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.7.1"     "g.7.2"     "g.7.3 "    "g.7.4"     "g.7.5"     "g.7.6"     "g.7.7"     "g.7.8"     "g.7.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        Ĺ") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.8.1"     "g.8.2"     "g.8.3 "    "g.8.4"     "g.8.5"     "g.8.6"     "g.8.7"     "g.8.8"     "g.8.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        Ĺ") 
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"          "g.9.1"     "g.9.2"     "g.9.3 "    "g.9.4"     "g.9.5"     "g.9.6"     "g.9.7"     "g.9.8"     "g.9.9"   ")
ret=LineOut(sudo,"                                                              ") 
ret=LineOut(sudo,"        ͼ")
ret=LineOut(sudo,"        Die Anzahl der freien Felder ist "nl"        Variante Nr.:")                 

call Locate 1,1; say
call Charout,"         ͻ"; say
call Charout,"                                                               "; say 
call Charout,"           "g.1.1"     "g.1.2"     "g.1.3 "    "g.1.4"     "g.1.5"     "g.1.6"     "g.1.7"     "g.1.8"     "g.1.9"   "; say  
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.2.1"     "g.2.2"     "g.2.3 "    "g.2.4"     "g.2.5"     "g.2.6"     "g.2.7"     "g.2.8"     "g.2.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.3.1"     "g.3.2"     "g.3.3 "    "g.3.4"     "g.3.5"     "g.3.6"     "g.3.7"     "g.3.8"     "g.3.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         ͹"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.4.1"     "g.4.2"     "g.4.3 "    "g.4.4"     "g.4.5"     "g.4.6"     "g.4.7"     "g.4.8"     "g.4.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.5.1"     "g.5.2"     "g.5.3 "    "g.5.4"     "g.5.5"     "g.5.6"     "g.5.7"     "g.5.8"     "g.5.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.6.1"     "g.6.2"     "g.6.3 "    "g.6.4"     "g.6.5"     "g.6.6"     "g.6.7"     "g.6.8"     "g.6.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         ͹"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.7.1"     "g.7.2"     "g.7.3 "    "g.7.4"     "g.7.5"     "g.7.6"     "g.7.7"     "g.7.8"     "g.7.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.8.1"     "g.8.2"     "g.8.3 "    "g.8.4"     "g.8.5"     "g.8.6"     "g.8.7"     "g.8.8"     "g.8.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         Ĺ"; say 
call Charout,"                                                               "; say 
call Charout,"           "g.9.1"     "g.9.2"     "g.9.3 "    "g.9.4"     "g.9.5"     "g.9.6"     "g.9.7"     "g.9.8"     "g.9.9"   "; say
call Charout,"                                                               "; say 
call Charout,"         ͼ";
say
neu2:
call Locate 41,8
call Charout,"(Wenn Sie  n  eingeben, werden die leeren Felder anders verteilt.)"
call Locate 42,4
call Charout,"(Alle Varianten beruhen auf demselben, hierfr erzeugten SUDOKU-Gesamtfeld.)"
call Locate 40,14
call Charout,"Gefllt diese Variante mit den "
call Color 1,green
call Charout,nl
call Color 0,white
call Charout," leeren Feldern? (j/n) "; 
ret=SysCurState("ON"); pull was; ret=SysCurState("OFF")

select
  when was == 'N' then
  do
    /* Datei sudo freigeben, weil sie sonst nicht gelscht werden kann. */
    call Charout(sudo)
    "del" sudo "1>NUL 2>NUL"
    call Locate 40,60
    call Charout,"                      "
    signal zufleer
  end
  when was == 'J' then
  do
     signal terwei
  end
  otherwise
  do
    call Locate 40,70
    Beep(884,200)
    call Charout,"               "
    signal neu2
  end
end

terwei:
keinecho:
call Locate 41,8
call Charout,"                                                                               "
call Locate 42,2
call Charout,"                  Nun mit der "
call Color 1,green
call Charout,"Leertaste"
call Color 1,white
call Charout," den EPM-Editor starten,                   "
call Locate 43,4
ret=SysCurState("OFF")
call Charout,"                                                                               "
call Locate 43,15
call Charout,"Vorlage gegebenenfalls beschriften und/oder ausdrucken";

/* Nur die Leertaste wirksam machen. */
aaa:
if c2x(SysGetKey("noecho"))==20 then signal terpull; else signal aaa

terpull:
Call SysCls
Call Color 1,white,blue
Call Locate  5,  2
Call Charout,"ͻ"
Call Locate  6,  2
Call Charout,"                                                                            "
Call Locate  7,  2
Call Charout,"   In den "
Call Color 1,yellow,blue
Call Charout,"Optionen"
Call Color 1,white,blue
Call Charout," des "
Call Color 1,cyan,blue
Call Charout,"EPM-Editors"
Call Color 1,white,blue
Call Charout," sollte folgendes eingestellt sein:       "
Call Locate  8,  2
Call Charout,"                                                                            "
Call Locate  9,  2
Call Charout,"   Anpassung -> Einstellungen -> Schrift:                                   ";
Call Locate 10,  2
Call Charout,"                                                                            "
Call Locate 11,  2
Call Charout,"            "
Call Color 1,yellow,blue
Call Charout,"          Schriftart:"
Call Color 1,green,blue
Call Charout,"    Courier Bitmap 25*15    Bold"
Call Color 1,white,blue
Call Charout,"           "
Call Locate 12,  2
Call Charout,"                                                                            "
Call Locate 13,  2
Call Charout,"                                                                            "
Call Locate 14,  2
Call Charout,"   Soll das Ergebnis ausgedruckt werden,                                    "
Call Locate 15,  2
Call Charout,"   so sollte in dem Fenster "
Call Color 1,yellow,blue
Call Charout," Drucken"
Call Color 1,white,blue
Call Charout,"                                        "
Call Locate 16,  2
Call Charout,"                                                                            "
Call Locate 17,  2
Call Charout,"   immer die Einstellung "
Call Color 1,green,blue
Call Charout,"Unformatierter ASCII-Text"
Call Color 1,white,blue
Call Charout," aktiviert sein.          "
Call Locate 18,  2
Call Charout,"                                                                            "
Call Locate 19,  2
Call Charout,"                                                                            "
Call Locate 20,  2
Call Charout,"                                                                            "
Call Locate 21,  2
Call Charout,"                                                                            "
Call Locate 22,  2
Call Charout,"   Weitere Auswahlmglichkeiten sind:                                       "
Call Locate 23,  2
Call Charout,"                                                                            "
Call Locate 24,  2
Call Charout,"      Die Einstellung "
call Color 1,cyan,blue
call Charout,"LPT1"
Call Color 1,white,blue
call Charout," whlen,                                       "
Call Locate 25,  2
Call Charout,"       wenn das SUDOKU-Rtsel vom lokalen Drucker ausgedruckt werden soll,  "
Call Locate 26,  2
Call Charout,"                                                                            "
Call Locate 27,  2
Call Charout,"      Die Einstellung "
call Color 1,cyan,blue
call Charout,"LPT3"
Call Color 1,white,blue
call Charout," whlen,                                       "
Call Locate 28,  2
Call Charout,"       wenn das SUDOKU-Rtsel als Fax mit PMFax versendet werden soll.      "
Call Locate 29,  2
Call Charout,"                                                                            "
Call Locate 30,  2
Call Charout,"                                                                            "
Call Locate 31,  2
Call Charout,"                          "
Call Color 1,green,blue
Call Charout,"Weiter mit der Leertaste"
Call Color 1,white,blue
Call Charout,"                          "
Call Locate 32,  2
Call Charout,"                                                                            "
Call Locate 33,  2
Call Charout,"ͼ"
call Color 0,white,black

/* Nur die Leertaste wirksam machen. */
aba:
if c2x(SysGetKey("noecho"))==20 then signal terpum; else signal aba

terpum:
call SysCls
/* Datei sudo freigeben, weil sie sonst nicht angezeigt werden kann. */
call Charout(sudo)
"C:\OS2\apps\epm.exe 'windowsize1 0 0 0 0 2048' " sudo "1>nul 2>nul"
call SysCls

neu3:        
ret=SysCurState("ON")
call Locate 8,10
call Charout,"Soll das Programm verlassen werden? (v) "
call Locate  9,10
call Charout,"oder soll von dem selben vollstndig ausgefllten SUDOKU-Grundschema"
call Locate 10,10
call Charout,"ein weiteres SUDOKU-Rtsel mit einer anderen Anzahl freier Felder"
call Locate 11,10
call Charout,"erzeugt werden? (j) "
Beep(800,500)
ret=SysCurState("ON"); pull ent2; ret=SysCurState("OFF")
 
select
  when ent2 == 'J' then
  do
    /* Datei sudo freigeben, weil sie sonst nicht gelscht werden kann. */
    call Charout(sudo)
    "del" sudo "1>NUL 2>NUL"
    call SysCls
    signal sudvers
  end
  when ent2 == 'V' then
  do
     signal PgmEnd
  end
  otherwise
  do
    call Locate 11,30
    call Charout,"                                                     "
    signal neu3
  end
end
 
PgmEnd:
"@ mode 80,25"
EXIT

   
Fehler_z:
Procedure
parse arg Meldung
ret=SysCurState("OFF")
Beep( 600,100) /* Eine             */
Beep( 756,100) /* Achtel-          */
Beep( 899,100) /* Triole           */
Beep(1200,300) /* Eine Viertelnote */
call Locate 10,29
call Charout,"Fehler "Meldung
return 
               
Fehler_s:
Procedure
parse arg Meldung
ret=SysCurState("OFF")
Beep( 600,100) /* Eine             */
Beep( 756,100) /* Achtel-          */
Beep( 899,100) /* Triole           */
Beep(1200,300) /* Eine Viertelnote */
call Locate 12,29
call Charout,"Fehler "Meldung
call Locate 17,20
call Charout,"Programm mit der Eingabetaste beenden"
pull
signal PgmEnd
return
  
/* ANSI-Prozeduren */

CsrUp: Procedure  /* CsrUp(Rows) */
Arg u
Rc = Charout(,D2C(27)"["u"A")
return ""

SaveCsr: procedure  /* cursor_location = SaveCsr() (for PutCsr(x))*/
Rc = Charout(,D2C(27)"[6n")/* in [6n  kleiner Buchstabe  n  wichtig ! */
Pull Q .
Call CsrUp
return substr(q,3,2) substr(q,6,2)
/* im Original  "return Q"  im Original */

PutCsr: procedure  /* Call PutCsr <Previous_Location>  (From SaveCsr() ) */
Where = arg(1)
Rc = Charout(,substr(Where,1,7)"H")
return ""

Locate: Procedure   /*  Call Locate Row,Col */
Row = arg(1)
Col = Arg(2)
Rc = Charout(,D2C(27)"["Row";"col"H")
return ""

CsrRight: Procedure  /* CsrRight(Cols) */
arg r
Rc = Charout(,D2C(27)"["r"C")
Return ""

CsrLeft: procedure  /* CsrLeft(Cols) */
arg l
Rc = Charout(,D2C(27)"["l"D")
Return ""

Color:     /* Call Color <Attr>,<ForeGround>,<BackGround>                */
Procedure  /* Attr=1 -> HIGH;  Attr=0 -> LOW; Attr only for ForeGround ! */
arg A,F,B
CLRS = "BLACK RED GREEN YELLOW BLUE MAGENTA CYAN WHITE"
A=strip(A); if length(A)==0 then A=0
F=strip(F); if length(F)==0 then F=WHITE
B=strip(B); if length(B)==0 then B=BLACK
return CHAROUT(,D2C(27)||"["A";"WORDPOS(F,CLRS)+29";"WORDPOS(B,CLRS)+39"m")

EndAll:
Call Color "White","Black"
